declare type OnPopupOpen = () => boolean | null;
declare type OnPopupClose = () => boolean | null;
declare type AfterPopupOpen = () => unknown;
declare type AfterPopupClose = () => unknown;
interface PopupOptions {
    menuDOM: HTMLElement;
    onOpen: OnPopupOpen;
    afterOpen: AfterPopupOpen;
    onClose: OnPopupClose;
    afterClose: AfterPopupClose;
}
declare class Popup {
    dom: HTMLElement;
    menuDOM: HTMLElement;
    popupIsOpen: boolean;
    onOpen: OnPopupOpen;
    onClose: OnPopupClose;
    afterOpen: AfterPopupOpen;
    afterClose: AfterPopupClose;
    constructor(options: PopupOptions);
    isPopupOpen: () => boolean;
    show: () => void;
    hide: () => void;
    mousedownHandler: (e: MouseEvent) => void;
    showPopup: (e: MouseEvent) => void;
    closePopup: (e?: MouseEvent) => void;
    setupEventListeners(): void;
}
export default Popup;
